/******************************************************************************
  (c) Copyright 2002-2008, 1060 Research Ltd                                   

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      
 *****************************************************************************/
package org.netkernel.container;

/** An external logger instance to receive kernel logging events
 * @author tab
 */
public interface ILogger extends IMessages
{
	// levels of logging
	public final static int SEVERE = 0;
	public final static int WARNING = 1;
	public final static int INFO = 2;
	public final static int FINE  = 3;
	public final static int FINER = 4;
	public final static int DEBUG = 5;
	public final static int CACHE = 6;
	
	/** Test to see if effort should be expended preparing a logging call
	 * @param aLevel The log level for the message.
	 * @param aCallingObject The object requesting the log message be recorded
	 * @return true if it should
	 */
	boolean shouldLog(int aLevel, Object aCallingObject);
	
	/**
	 *  Adds a raw log entry with zero parameters.
	 *  @param msg  The log message to be recorded.
	 *  @param level  The log level for the message.
	 *  @param callingObject  The object requesting the log message be recorded
	 */
	public void logRaw(int level, Object callingObject, String _msg);

	/**
	 *  Adds a log entry with four parameters.
	 *  @param level  The log level for the message.
	 *  @param callingObject  The object requesting the log message be recorded
	 *  @param msg  The message key to record.
	 *  @param p  A variable number of parameters to substitute into message
	 */
	public void log(int level, Object callingObject, String msg, Object... p);
}