/******************************************************************************
  (c) Copyright 2002-2008, 1060 Research Ltd                                   

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      
 *****************************************************************************/
package org.netkernel.request;

/** An IExpiry object can indicate if it has expired or become invalid
 * at a specific time.
 *
 * The design intent is for IExpiry to be used to indicate the validity
 * of responses. Typically expiries remain false for a duration before
 * permanently becoming true.
 *
 * @author tab
 * @see 
 */
public interface IExpiry
{
	/** Return indication if this object has expired at the specified time.
   *
	 * @param aTime the time for which expiration is tested. Typically this
	 * time is "now" and an implementation doesn't need to try too hard to
	 * predict the future or keep a history of past states. Expiry functions
	 * should usually be mono-stable once they become expired they should
	 * remain expired indefinitely.
	 * @return Indication if the object has expired as of the specified time.
	 */
	boolean isExpired(long aTime);
}
